﻿Type=Service
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
	
	
#End Region
 Sub Process_Globals
 	
	Private session As JavaObject
	Private BroadcastReceiver As BroadCastReceiver
	Private v As PhoneVibrate
	
 End Sub

 Sub Service_Create
	
	Dim context As JavaObject
       
	Try 		
		' // broadcast receiver
		BroadcastReceiver.Initialize("BroadcastReceiver")
		
'		' // media sessions
	   	context.InitializeContext

'     	session.InitializeNewInstance("android.media.session.MediaSession", Array(context, "tag")) ' working
'	  	
'		' // media sessopn callback
'		Dim cb As JavaObject
'       	cb.InitializeNewInstance(Application.PackageName & ".starter.MyCallback", Null)
'        session.RunMethod("setCallback", Array(cb))     
'        session.RunMethod("setFlags",Array(3))
'        session.RunMethod("setActive", Array(True))
	
		Dim ComponentName As JavaObject
		ComponentName.InitializeNewInstance("android.content.ComponentName",Array(Application.PackageName,"starter$MyReceiver"))
		
		session.InitializeNewInstance("android.support.v4.media.session.MediaSessionCompat", Array(context, "tag", Null, Null))

		Dim CallBack As JavaObject
		CallBack.InitializeNewInstance(Application.PackageName & ".starter.MyCallback", Null)
		session.RunMethod("setCallback", Array(CallBack))

		session.RunMethod("setFlags",Array(3))
		session.RunMethod("setActive", Array(True))
	
	
	Catch
	
		mod_vars.LastStarterMessage = LastException.Message
				
	End Try	
		
		
    End Sub

  Sub Service_Start (StartingIntent As Intent)
	
	' // setup broadcast reciever for head set plug/unplug
	BroadcastReceiver.addAction("android.intent.action.HEADSET_PLUG")
   	BroadcastReceiver.SetPriority(2147483647)
   	BroadcastReceiver.registerReceiver("")
   
	If mod_vars.LastStarterMessage.Length = 0 Then
  		mod_vars.LastStarterMessage = "Starter Service Running" 
  	End If
	
 End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
    Return True
End Sub

Sub Service_Destroy
	
	Try
		BroadcastReceiver.unregisterReceiver 
	    session.RunMethod("release",Null)
	Catch
		LogColor(LastException.Message,Colors.Red )
	End Try

End Sub

#Region "HeadSetPlug Reveiver"
Sub BroadcastReceiver_OnReceive (Action As String, i As Object)
    
	Dim i2 As Intent = i 
		
		
	Log(DateTime.Time(DateTime.Now) & " BroadcastReceiver_OnReceive(),  " & Action)
	Log(DateTime.Time(DateTime.Now) & " BroadcastReceiver_OnReceive(),  " & i2.ExtrasToString )
	
	mod_vars.HeadSetState = i2.GetExtra("state")
	
	setSpeakerPhone(mod_vars.HeadSetState)			
	
		
End Sub

Sub setSpeakerPhone(state As Int)
	
	Dim s As Boolean = False
	
	If state = 1 Then
		s = True	
	End If
	
	mod_vars.SpeakerPhoneState = s
	
	If s Then
		If Not(mod_vars.SpeakerPhoneRouted) Then
			If s Then
				' // dsiable headset microphone
				reroute_speakerphone(0)
				mod_vars.SpeakerPhoneRouted = True
				v.Vibrate(100) 
			End If
		End If
	Else
		If mod_vars.SpeakerPhoneRouted Then
			mod_vars.SpeakerPhoneRouted = False
			v.Vibrate(100) 
		End If
	End If	
	
	
'	/*
'     * AudioPolicyService methods
'     */
'
'    //
'    // audio device definitions: must be kept in sync with values in system/core/audio.h
'    //
'
'    Public static final int DEVICE_NONE = 0x0;
'    // reserved bits
'    Public static final int DEVICE_BIT_IN = 0x80000000;
'    Public static final int DEVICE_BIT_DEFAULT = 0x40000000;
'    // output devices, be sure To update AudioManager.java also
'    Public static final int DEVICE_OUT_EARPIECE = 0x1;
'    Public static final int DEVICE_OUT_SPEAKER = 0x2;
'    Public static final int DEVICE_OUT_WIRED_HEADSET = 0x4;
'    Public static final int DEVICE_OUT_WIRED_HEADPHONE = 0x8;
'    Public static final int DEVICE_OUT_BLUETOOTH_SCO = 0x10;
'    Public static final int DEVICE_OUT_BLUETOOTH_SCO_HEADSET = 0x20;
'    Public static final int DEVICE_OUT_BLUETOOTH_SCO_CARKIT = 0x40;
'    Public static final int DEVICE_OUT_BLUETOOTH_A2DP = 0x80;
'    Public static final int DEVICE_OUT_BLUETOOTH_A2DP_HEADPHONES = 0x100;
'    Public static final int DEVICE_OUT_BLUETOOTH_A2DP_SPEAKER = 0x200;
'    Public static final int DEVICE_OUT_AUX_DIGITAL = 0x400;
'    Public static final int DEVICE_OUT_HDMI = DEVICE_OUT_AUX_DIGITAL;
'    Public static final int DEVICE_OUT_ANLG_DOCK_HEADSET = 0x800;
'    Public static final int DEVICE_OUT_DGTL_DOCK_HEADSET = 0x1000;
'    Public static final int DEVICE_OUT_USB_ACCESSORY = 0x2000;
'    Public static final int DEVICE_OUT_USB_DEVICE = 0x4000;
'    Public static final int DEVICE_OUT_REMOTE_SUBMIX = 0x8000;
'    Public static final int DEVICE_OUT_TELEPHONY_TX = 0x10000;
'    Public static final int DEVICE_OUT_LINE = 0x20000;
'    Public static final int DEVICE_OUT_HDMI_ARC = 0x40000;
'    Public static final int DEVICE_OUT_SPDIF = 0x80000;
'    Public static final int DEVICE_OUT_FM = 0x100000;
'    Public static final int DEVICE_OUT_AUX_LINE = 0x200000;
'    Public static final int DEVICE_OUT_SPEAKER_SAFE = 0x400000;
'    Public static final int DEVICE_OUT_IP = 0x800000;

	
End Sub

Sub reroute_speakerphone(state As Int)

	Dim jo As JavaObject
	jo.InitializeContext
	
	Dim r As Reflector
	
	Try
		r.Target = jo.RunMethod("getSystemService", Array("audio"))
		r.RunMethod4("setWiredDeviceConnectionState", Array (4, state, "device"), _
					Array As String("java.lang.int", "java.lang.int", "java.lang.String"))
	Catch
		mod_vars.LastStarterMessage = LastException.Message
	End Try

End Sub
#End Region

'Sub Media_OnButton(Intent As Intent) As Boolean
'    
'	Log(Intent.Action)
'	Log(Intent.ExtrasToString)
'	
'	process_intent(Intent)
'	Return True
'	
'	
'End Sub
	
	
Sub process_intent(i As Intent )

	Dim sf As StringFunctions
	

	sf.Initialize 
	
	If sf.InString(i.ExtrasToString,"action=ACTION_DOWN") >= 0 Then
		v.Vibrate(100) 
		' // start press count
		If Main.pressTime = 0 Then
			Main.pressTime = DateTime.Now
			Log(DateTime.Time(DateTime.Now) & " Start Button Press")
		End If
		CallSub(Main,"clear_list")

	End If

	If sf.InString(i.ExtrasToString,"action=ACTION_UP") >= 0 Then
		Log(DateTime.Time(DateTime.Now) & Round2((DateTime.Now - Main.pressTime) / DateTime.TicksPerSecond,2))
		Main.pressTime = 0
		Log(DateTime.Time(DateTime.Now) & " End Button Press")
	End If

	CallSub2(Main,"add_intent",i)
	
	
	
End Sub
'''	 - PRE API 21 Method
'''#if java
'''
'''    import android.media.session.MediaSession.*;
'''	import android.os.Bundle;
'''    import android.os.ResultReceiver;
'''    import android.content.Intent;
'''    import anywheresoftware.b4a.objects.IntentWrapper;
'''
'''    public static class MyCallback extends Callback {
'''       public MyCallback() {
'''       }
'''       public void onCommand(String command, Bundle args, ResultReceiver cb) {
'''       BA.Log(command);
'''         processBA.raiseEventFromUI(null, "media_oncommand", command);
'''       }
'''       public boolean onMediaButtonEvent(Intent mediaButtonIntent) {
'''         IntentWrapper baIntent = new IntentWrapper();
'''         baIntent.setObject(mediaButtonIntent);
'''        Boolean b = (Boolean) processBA.raiseEvent(null, "media_onbutton", baIntent);
'''        return b == null ? false : b;
'''       }
'''    }
'''#end if

' // Post API 21+ method

Sub Media_OnCommand(Command As String)
   Log(Command)
End Sub
Sub Media_OnButton(Intent As Intent) As Boolean
	Log(Intent.ExtrasToString)
	process_intent(Intent)
	Return False
End Sub
#if java

import android.support.v4.media.session.MediaSessionCompat.*;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.IntentWrapper;
import android.os.Bundle;
import android.os.ResultReceiver;
import android.content.IntentFilter;

public static class MyReceiver extends BroadcastReceiver {
	   public MyReceiver() {
	   super();
	   }
	   
	@Override
	public void onReceive(Context context, Intent intent) {
		 IntentWrapper baIntent = new IntentWrapper();
		 baIntent.setObject(intent);
	     processBA.raiseEventFromUI(null, "media_onbutton", baIntent);
		 abortBroadcast();
	}
}

public static class MyCallback extends Callback {
   public MyCallback() {
   }
   public void onCommand(String command, Bundle args, ResultReceiver cb) {
     processBA.raiseEventFromUI(null, "media_oncommand", command);
   }
   public boolean onMediaButtonEvent(Intent mediaButtonIntent) {
   	 IntentWrapper baIntent = new IntentWrapper();
	 baIntent.setObject(mediaButtonIntent);
     Boolean b = (Boolean) processBA.raiseEvent(null, "media_onbutton", baIntent);
	 return b == null ? false : b;
   }
}
#end if
     

